package org.dromara.biz.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.dromara.biz.domain.bo.BizCsformBo;
import org.dromara.biz.domain.vo.BizCsformVo;
import org.dromara.biz.domain.BizCsform;
import org.dromara.biz.mapper.BizCsformMapper;
import org.dromara.biz.service.IBizCsformService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 测试单Service业务层处理
 *
 * @author Blue
 * @date 2025-05-14
 */
@RequiredArgsConstructor
@Service
public class BizCsformServiceImpl implements IBizCsformService {

    private final BizCsformMapper baseMapper;

    /**
     * 查询测试单
     *
     * @param id 主键
     * @return 测试单
     */
    @Override
    public BizCsformVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询测试单列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 测试单分页列表
     */
    @Override
    public TableDataInfo<BizCsformVo> queryPageList(BizCsformBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<BizCsform> lqw = buildQueryWrapper(bo);
        Page<BizCsformVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的测试单列表
     *
     * @param bo 查询条件
     * @return 测试单列表
     */
    @Override
    public List<BizCsformVo> queryList(BizCsformBo bo) {
        LambdaQueryWrapper<BizCsform> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<BizCsform> buildQueryWrapper(BizCsformBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<BizCsform> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(BizCsform::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getTitle()), BizCsform::getTitle, bo.getTitle());
        lqw.eq(StringUtils.isNotBlank(bo.getType()), BizCsform::getType, bo.getType());
        lqw.eq(StringUtils.isNotBlank(bo.getContent()), BizCsform::getContent, bo.getContent());
        lqw.eq(StringUtils.isNotBlank(bo.getFile()), BizCsform::getFile, bo.getFile());
        return lqw;
    }

    /**
     * 新增测试单
     *
     * @param bo 测试单
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(BizCsformBo bo) {
        BizCsform add = MapstructUtils.convert(bo, BizCsform.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改测试单
     *
     * @param bo 测试单
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(BizCsformBo bo) {
        BizCsform update = MapstructUtils.convert(bo, BizCsform.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(BizCsform entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除测试单信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
